using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace Mod
{
    public class Mod
    {

       public static void Main()
       {
CategoryBuilder.Create("United States Army", "", ModAPI.LoadSprite("Category.png"));
ModAPI.Register(
new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"),
        NameOverride = "U.S. Army Soldier (Combat Shirt)", 
        DescriptionOverride = "Half Camo Shirt", 
        CategoryOverride = ModAPI.FindCategory("United States Army"),
        ThumbnailOverride = ModAPI.LoadSprite("View/Soldier.png"),
        AfterSpawn = (Instance) => 
        {
        var skin = ModAPI.LoadTexture("Sprite/Soldier.png");
        var flesh = ModAPI.LoadTexture("Flesh.png");
        var bone = ModAPI.LoadTexture("Bone.png");

        var person = Instance.GetComponent<PersonBehaviour>();

        person.SetBodyTextures(skin, flesh, bone, 10);
        }
    }
);
ModAPI.Register(
new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"),
        NameOverride = "U.S. Army Soldier (Combat Shirt, Rolled)", 
        DescriptionOverride = "Half Camo Shirt/Rolled up Sleeves", 
        CategoryOverride = ModAPI.FindCategory("United States Army"),
        ThumbnailOverride = ModAPI.LoadSprite("View/SoldierSleeve.png"),
        AfterSpawn = (Instance) => 
        {
        var skin = ModAPI.LoadTexture("Sprite/SoldierSleeve.png");
        var flesh = ModAPI.LoadTexture("Flesh.png");
        var bone = ModAPI.LoadTexture("Bone.png");

        var person = Instance.GetComponent<PersonBehaviour>();

        person.SetBodyTextures(skin, flesh, bone, 10);
        }
    }
);
ModAPI.Register(
new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"),
        NameOverride = "U.S. Army Soldier (Blouse)", 
        DescriptionOverride = "Full Camo Shirt", 
        CategoryOverride = ModAPI.FindCategory("United States Army"),
        ThumbnailOverride = ModAPI.LoadSprite("View/SoldierCamo.png"),
        AfterSpawn = (Instance) => 
        {
        var skin = ModAPI.LoadTexture("Sprite/SoldierCamo.png");
        var flesh = ModAPI.LoadTexture("Flesh.png");
        var bone = ModAPI.LoadTexture("Bone.png");

        var person = Instance.GetComponent<PersonBehaviour>();

        person.SetBodyTextures(skin, flesh, bone, 10);
        }
    }
);
ModAPI.Register(
new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"),
        NameOverride = "U.S. Army Soldier (Blouse, Rolled)", 
        DescriptionOverride = "Full Camo Shirt/Rolled up Sleeves", 
        CategoryOverride = ModAPI.FindCategory("United States Army"),
        ThumbnailOverride = ModAPI.LoadSprite("View/SoldierCamoSleeve.png"),
        AfterSpawn = (Instance) => 
        {
        var skin = ModAPI.LoadTexture("Sprite/SoldierCamoSleeve.png");
        var flesh = ModAPI.LoadTexture("Flesh.png");
        var bone = ModAPI.LoadTexture("Bone.png");

        var person = Instance.GetComponent<PersonBehaviour>();

        person.SetBodyTextures(skin, flesh, bone, 10);
        }
    }
);
ModAPI.Register(
new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "U.S. Army FAST Helmet (Cover)",
        DescriptionOverride = "Future Assault Shell Technology Helmet/Multicam Helmet Cover", 
        CategoryOverride = ModAPI.FindCategory("United States Army"),
        ThumbnailOverride = ModAPI.LoadSprite("View/HelmetCover.png"),
        AfterSpawn = (Instance) => 
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprite/HelmetCover.png",10f);

            if (!Instance.GetComponent<ArmorBehaviour>())
            Instance.AddComponent<ArmorBehaviour>();

            ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

            ArmorProperties prop = new ArmorProperties();
                        
            prop.armorPiece = "Head";
            prop.armorTier = 250;
            prop.scaleOffset = new Vector3(.0f, .0f);
            prop.offset = new Vector3(.0f, .0f);
            prop.sprite = "Sprite/HelmetCover.png";

            armor.prop = prop;
            armor.SetProperties();

            ArmorProperties[] armProp = new ArmorProperties[0];           
            Instance.FixColliders();
      }
   }
);
ModAPI.Register(
new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "U.S. Army FAST Helmet",
        DescriptionOverride = "Future Assault Shell Technology Helmet", 
        CategoryOverride = ModAPI.FindCategory("United States Army"),
        ThumbnailOverride = ModAPI.LoadSprite("View/Helmet.png"),
        AfterSpawn = (Instance) => 
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprite/Helmet.png",10f);

            if (!Instance.GetComponent<ArmorBehaviour>())
            Instance.AddComponent<ArmorBehaviour>();

            ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

            ArmorProperties prop = new ArmorProperties();
                        
            prop.armorPiece = "Head";
            prop.armorTier = 250;
            prop.scaleOffset = new Vector3(.0f, .0f);
            prop.offset = new Vector3(.0f, .0f);
            prop.sprite = "Sprite/Helmet.png";

            armor.prop = prop;
            armor.SetProperties();

            ArmorProperties[] armProp = new ArmorProperties[0];           
            Instance.FixColliders();
      }
   }
);
ModAPI.Register(
new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "U.S. Army Advanced Combat Helmet (Cover)",
        DescriptionOverride = "Multicam Helmet Cover", 
        CategoryOverride = ModAPI.FindCategory("United States Army"),
        ThumbnailOverride = ModAPI.LoadSprite("View/HelmetADVCover.png"),
        AfterSpawn = (Instance) => 
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprite/HelmetADVCover.png",10f);

            if (!Instance.GetComponent<ArmorBehaviour>())
            Instance.AddComponent<ArmorBehaviour>();

            ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

            ArmorProperties prop = new ArmorProperties();
                        
            prop.armorPiece = "Head";
            prop.armorTier = 250;
            prop.scaleOffset = new Vector3(.0f, .0f);
            prop.offset = new Vector3(.0f, .0f);
            prop.sprite = "Sprite/HelmetADVCover.png";

            armor.prop = prop;
            armor.SetProperties();

            ArmorProperties[] armProp = new ArmorProperties[0];           
            Instance.FixColliders();
      }
   }
);
ModAPI.Register(
new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "U.S. Army Advanced Combat Helmet Helmet",
        DescriptionOverride = "", 
        CategoryOverride = ModAPI.FindCategory("United States Army"),
        ThumbnailOverride = ModAPI.LoadSprite("View/HelmetADV.png"),
        AfterSpawn = (Instance) => 
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprite/HelmetADV.png",10f);

            if (!Instance.GetComponent<ArmorBehaviour>())
            Instance.AddComponent<ArmorBehaviour>();

            ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

            ArmorProperties prop = new ArmorProperties();
                        
            prop.armorPiece = "Head";
            prop.armorTier = 250;
            prop.scaleOffset = new Vector3(.0f, .0f);
            prop.offset = new Vector3(.0f, .0f);
            prop.sprite = "Sprite/HelmetADV.png";

            armor.prop = prop;
            armor.SetProperties();

            ArmorProperties[] armProp = new ArmorProperties[0];           
            Instance.FixColliders();
      }
   }
);
ModAPI.Register(
new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "U.S. Army Plate Carrier System (Upper)", 
        DescriptionOverride = "", 
        CategoryOverride = ModAPI.FindCategory("United States Army"),
        ThumbnailOverride = ModAPI.LoadSprite("View/ArmorUpper.png"),
        AfterSpawn = (Instance) => 
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprite/ArmorUpper.png",10f);

            if (!Instance.GetComponent<ArmorBehaviour>())
            Instance.AddComponent<ArmorBehaviour>();

            ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

            ArmorProperties prop = new ArmorProperties();
                        
            prop.armorPiece = "UpperBody";
            prop.armorTier = 250;
            prop.scaleOffset = new Vector3(.0f, .0f);
            prop.offset = new Vector3(.0f, .0f);
            prop.sprite = "Sprite/ArmorUpper.png";

            armor.prop = prop;
            armor.SetProperties();

            ArmorProperties[] armProp = new ArmorProperties[0];           
            Instance.FixColliders();
      }
   }
);
ModAPI.Register(
new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "U.S. Army Plate Carrier System (Lower)", 
        DescriptionOverride = "", 
        CategoryOverride = ModAPI.FindCategory("United States Army"),
        ThumbnailOverride = ModAPI.LoadSprite("View/ArmorLower.png"),
        AfterSpawn = (Instance) => 
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprite/ArmorLower.png",10f);

            if (!Instance.GetComponent<ArmorBehaviour>())
            Instance.AddComponent<ArmorBehaviour>();

            ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

            ArmorProperties prop = new ArmorProperties();
                        
            prop.armorPiece = "MiddleBody";
            prop.armorTier = 250;
            prop.scaleOffset = new Vector3(.0f, .0f);
            prop.offset = new Vector3(.0f, .0f);
            prop.sprite = "Sprite/ArmorLower.png";

            armor.prop = prop;
            armor.SetProperties();

            ArmorProperties[] armProp = new ArmorProperties[0];           
            Instance.FixColliders();
      }
   }
);
ModAPI.Register(
new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "U.S. Army Modular Scalable Vest (Upper)", 
        DescriptionOverride = "", 
        CategoryOverride = ModAPI.FindCategory("United States Army"),
        ThumbnailOverride = ModAPI.LoadSprite("View/ArmorUpperScale.png"),
        AfterSpawn = (Instance) => 
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprite/ArmorUpperScale.png",10f);

            if (!Instance.GetComponent<ArmorBehaviour>())
            Instance.AddComponent<ArmorBehaviour>();

            ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

            ArmorProperties prop = new ArmorProperties();
                        
            prop.armorPiece = "UpperBody";
            prop.armorTier = 250;
            prop.scaleOffset = new Vector3(.0f, .0f);
            prop.offset = new Vector3(.0f, .0f);
            prop.sprite = "Sprite/ArmorUpperScale.png";

            armor.prop = prop;
            armor.SetProperties();

            ArmorProperties[] armProp = new ArmorProperties[0];           
            Instance.FixColliders();
      }
   }
);
ModAPI.Register(
new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "U.S. Army Modular Scalable Vest (Lower)", 
        DescriptionOverride = "", 
        CategoryOverride = ModAPI.FindCategory("United States Army"),
        ThumbnailOverride = ModAPI.LoadSprite("View/ArmorLowerScale.png"),
        AfterSpawn = (Instance) => 
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprite/ArmorLowerScale.png",10f);

            if (!Instance.GetComponent<ArmorBehaviour>())
            Instance.AddComponent<ArmorBehaviour>();

            ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

            ArmorProperties prop = new ArmorProperties();
                        
            prop.armorPiece = "MiddleBody";
            prop.armorTier = 250;
            prop.scaleOffset = new Vector3(.0f, .0f);
            prop.offset = new Vector3(.0f, .0f);
            prop.sprite = "Sprite/ArmorLowerScale.png";

            armor.prop = prop;
            armor.SetProperties();

            ArmorProperties[] armProp = new ArmorProperties[0];           
            Instance.FixColliders();
      }
   }
);
ModAPI.Register(
new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "U.S. Army - backpack", 
        DescriptionOverride = "", 
        CategoryOverride = ModAPI.FindCategory("United States Army"),
        ThumbnailOverride = ModAPI.LoadSprite("View/Backpack.png"),
        AfterSpawn = (Instance) => 
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprite/Backpack.png",10f);

            if (!Instance.GetComponent<ArmorBehaviour>())
            Instance.AddComponent<ArmorBehaviour>();

            ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

            ArmorProperties prop = new ArmorProperties();
                        
            prop.armorPiece = "UpperBody";
            prop.armorTier = 3;
            prop.scaleOffset = new Vector3(.0f, .0f);
            prop.offset = new Vector3(.0f, .0f);
            prop.sprite = "Sprite/Backpack.png";

            armor.prop = prop;
            armor.SetProperties();

            ArmorProperties[] armProp = new ArmorProperties[0];           
            Instance.FixColliders();
      }
   }
);
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Assault Rifle"),
        NameOverride = "M4a1", 
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("United States Army"), 
        ThumbnailOverride = ModAPI.LoadSprite("View/M4a1.png"), 
        AfterSpawn = (Instance) => 
        {
        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprite/M4a1.png",10f);
        }
    }
);
        }
    }
}